Index: /trunk/src/lib/network/network_game_manager.cc
===================================================================
--- /trunk/src/lib/network/network_game_manager.cc	(revision 7953)
+++ /trunk/src/lib/network/network_game_manager.cc	(revision 7954)
@@ -27,4 +27,5 @@
 #include "shared_network_data.h"
 #include "converter.h"
+#include "message_manager.h"
 
 #include "playable.h"
@@ -52,6 +53,7 @@
   this->setClassID(CL_NETWORK_GAME_MANAGER, "NetworkGameManager");
 
-  hasRequestedWorld = false;
   this->setSynchronized(true);
+  
+  MessageManager::getInstance()->registerMessageHandler( MSGID_YOU_ARE, youAreHandler, NULL );
 }
 
@@ -61,4 +63,5 @@
 NetworkGameManager::~NetworkGameManager()
 {
+#if 0
   for ( int i = 0; i<outBuffer.size(); i++)
   {
@@ -66,8 +69,9 @@
       delete outBuffer[i].buffer;
   }
-
-}
-
-
+#endif
+
+}
+
+#if 0
 int NetworkGameManager::writeBytes(const byte* data, int length, int sender)
 {
@@ -141,10 +145,4 @@
     {
       sendEntityList( sender );
-      continue;
-    }
-    else if ( b == NET_REQUEST_SYNC )
-    {
-      if ( !handleRequestSync( i, data, length, sender ) )
-        return i;
       continue;
     }
@@ -160,5 +158,7 @@
   return i;
 }
-
+#endif
+
+#if 0
 int NetworkGameManager::readBytes(byte* data, int maxLength, int * reciever)
 {
@@ -192,5 +192,7 @@
   return 0;
 }
-
+#endif
+
+#if 0
 void NetworkGameManager::writeDebug() const
 {
@@ -200,4 +202,5 @@
 {
 }
+#endif
 
 
@@ -211,14 +214,19 @@
   if ( this->isServer())
   {
-    if ( SharedNetworkData::getInstance()->getNewUniqueID() < 0 )
+    int res = this->executeCreateEntity( classID, SharedNetworkData::getInstance()->getNewUniqueID(), owner );
+    
+    if ( res < 0 )
     {
       PRINTF(1)("Cannot create entity! There are no more uniqueIDs left!\n");
       return -1;
     }
-    return this->executeCreateEntity( classID, SharedNetworkData::getInstance()->getNewUniqueID(), owner );
+    
+    return res;
   }
   else
   {
+#if 0
     this->requestCreateEntity( classID );
+#endif
     return -1;
   }
@@ -288,10 +296,12 @@
   else
   {
+#if 0
     this->requestRemoveEntity( uniqueID );
-  }
-}
-
-
-
+#endif
+  }
+}
+
+
+#if 0
 /*!
  * Creates the needed entity on the server if possible
@@ -311,5 +321,7 @@
   }
 }
-
+#endif
+
+#if 0
 /*!
  * Removes the specified entity on the server
@@ -329,4 +341,5 @@
   }
 }
+#endif
 
 /*!
@@ -337,4 +350,5 @@
 int NetworkGameManager::executeCreateEntity(ClassID classID, int uniqueID, int owner)
 {
+#if 0
   for ( int i = 0; i<outBuffer.size(); i++)
   {
@@ -351,5 +365,5 @@
       return -1;
   }
-
+#endif
   PRINTF(0)("ExecuteCreateEntity: server side: classID: %x, uniqueID: %i, owner: %i\n", classID, uniqueID, owner);
   doCreateEntity( classID, uniqueID, owner );
@@ -365,4 +379,5 @@
 void NetworkGameManager::executeRemoveEntity(int uniqueID)
 {
+#if 0
   for ( int i = 0; i<outBuffer.size(); i++)
   {
@@ -375,4 +390,5 @@
       return;
   }
+#endif
 
   doRemoveEntity(uniqueID);
@@ -388,4 +404,5 @@
 }
 
+#if 0
 /*!
  * Sends the Entities to the new connected client
@@ -443,4 +460,5 @@
   signalNewPlayer( userID );
 }
+#endif
 
 
@@ -448,7 +466,4 @@
 bool NetworkGameManager::signalNewPlayer(int userId)
 {
-  if ( userId >= outBuffer.size() )
-    resizeBufferVector( userId );
-
   /* create new playable for Player*/
   PRINTF(0)("Request for creation: %i\n", userId);
@@ -456,5 +471,4 @@
   PRINTF(0)("Request for creation: userid: %i, uniqueid: %i\n", userId, uniqueId);
   this->sendYouAre(uniqueId, userId);
-
 }
 
@@ -464,4 +478,8 @@
 {
   const std::list<BaseObject*>* playableList = ClassList::getList(CL_PLAYABLE);
+  
+  if ( !playableList )
+    return false;
+  
   std::list<BaseObject*>::const_iterator it = playableList->begin();
 
@@ -478,5 +496,5 @@
 }
 
-
+#if 0
 /**
  * Creates a buffer for user n
@@ -498,4 +516,5 @@
   }
 }
+#endif
 
 /**
@@ -532,6 +551,5 @@
     s->setSynchronized(true);
     //this->networkStream->connectSynchronizeable( *s );
-    if ( !isServer() )
-      s->setIsOutOfSync( true );
+
     PRINTF(0)("Fabricated %s with id %d\n", s->getClassName(), s->getUniqueID());
 
@@ -601,26 +619,5 @@
 }
 
-/**
- * Tell the synchronizeable that a user's synchronizeable is out of sync
- * @param uniqueID: unique ID assigned with the entity which is out of sync
- * @param userID: user ID who's synchronizeable is out of sync
- */
-void NetworkGameManager::doRequestSync( int uniqueID, int userID )
-{
-  SynchronizeableList::const_iterator it,e;
-  it = this->networkStream->getSyncBegin();
-  e = this->networkStream->getSyncEnd();
-
-  while ( it != e )
-  {
-    if ( (*it)->getUniqueID() == uniqueID )
-    {
-      (*it)->requestSync( userID );
-      break;
-    }
-    it++;
-  }
-}
-
+#if 0
 /**
  * Copies length bytes to the clientBuffer with error checking
@@ -641,5 +638,7 @@
   return true;
 }
-
+#endif
+
+#if 0
 /**
  * Reads data from clientBuffer with error checking
@@ -660,4 +659,5 @@
   return true;
 }
+#endif
 
 /**
@@ -687,5 +687,5 @@
       } else
       {
-        PRINTF(1)("UniqueID is not a Playable\n");
+        PRINTF(1)("UniqueID %d is not a Playable\n", uniqueID);
       }
     }
@@ -697,6 +697,4 @@
   assert(player != NULL);
 
-  s->setIsOutOfSync( true );
-
   PRINTF(0)("uniqueID = %d\n", s->getUniqueID());
 
@@ -715,17 +713,10 @@
   if ( !isServer() )
     return;
-
-  if ( userID != 0 )
-  {
-    if ( !writeToClientBuffer( outBuffer[userID], (byte)NET_YOU_ARE_ENTITY ) )
-      return;
-
-    if ( !writeToClientBuffer( outBuffer[userID], uniqueID ) )
-      return;
-  }
-  else
-  {
-    doYouAre(uniqueID);
-  }
+  
+  byte buf[INTSIZE];
+  
+  Converter::intToByteArray( uniqueID, buf, INTSIZE );
+  
+  MessageManager::getInstance()->sendMessage( MSGID_YOU_ARE, buf, INTSIZE, RT_USER, userID, MP_HIGHBANDWIDTH);
 }
 
@@ -902,21 +893,4 @@
   return true;
 }
-
-bool NetworkGameManager::handleRequestSync( int & i, const byte * data, int length, int sender )
-{
-  if ( INTSIZE > length-i )
-  {
-    PRINTF(1)("Cannot read uniqueID from buffer! Not enough data left!\n");
-    return false;
-  }
-  int uniqueID;
-  i += Converter::byteArrayToInt( &data[i], &uniqueID );
-
-  PRINTF(0)("handleRequestSync %d %d\n", uniqueID, sender);
-  doRequestSync( uniqueID, sender );
-
-  return true;
-}
-
 
 /**
@@ -958,5 +932,33 @@
 }
 
-
+bool NetworkGameManager::youAreHandler( MessageId messageId, byte * data, int dataLength, void * someData, int userId )
+{
+  assert( dataLength == INTSIZE );
+  int uniqueId;
+  
+  Converter::byteArrayToInt( data, &uniqueId );
+  
+  SynchronizeableList::const_iterator it = NetworkGameManager::getInstance()->networkStream->getSyncBegin();
+
+  Playable *p = NULL;
+  Synchronizeable *s = NULL;
+
+  for ( ; it !=NetworkGameManager::getInstance()->networkStream->getSyncEnd(); it++ )
+  {
+    if ( (*it)->getUniqueID()==uniqueId )
+    {
+      break;
+    }
+  }
+  
+  if ( it == NetworkGameManager::getInstance()->networkStream->getSyncEnd() )
+    return false;
+  
+  NetworkGameManager::getInstance()->doYouAre( uniqueId );
+  
+  return true;
+}
+
+#if 0
 bool NetworkGameManager::writeToClientBuffer( clientBuffer & cb, byte b )
 {
@@ -971,4 +973,5 @@
   return true;
 }
+
 
 bool NetworkGameManager::writeToClientBuffer( clientBuffer & cb, int i )
@@ -985,26 +988,5 @@
   return true;
 }
-
-void NetworkGameManager::sync( int uniqueID, int owner )
-{
-  /*if ( owner==this->getHostID() )
-  return;*/
-
-  if ( !isServer() )
-    executeRequestSync( uniqueID, 0 );
-  else
-    executeRequestSync( uniqueID, owner );
-}
-
-void NetworkGameManager::executeRequestSync( int uniqueID, int user )
-{
-  PRINTF(0)("executeRequestSync %d %d\n", uniqueID, user);
-  if ( user >= outBuffer.size() )
-    resizeBufferVector( user );
-
-  if ( !writeToClientBuffer( outBuffer[user], (byte)NET_REQUEST_SYNC ) )
-    return;
-  if ( !writeToClientBuffer( outBuffer[user], uniqueID ) )
-    return;
-}
-
+#endif
+
+
Index: /trunk/src/lib/network/network_game_manager.h
===================================================================
--- /trunk/src/lib/network/network_game_manager.h	(revision 7953)
+++ /trunk/src/lib/network/network_game_manager.h	(revision 7954)
@@ -12,38 +12,9 @@
 /* include base_object.h since all classes are derived from this one */
 #include "synchronizeable.h"
+#include "message_manager.h"
 
 
 class TiXmlElement;
 class PNode;
-
-/**
- * protocol definition
- *
- *  CREATE_ENTITY:       >> CLASS_ID, UNIQUE_ID, OWNER
- *  REMOVE_ENTITY:       >> UNIQUE_ID
- *
- *  CREATE_ENTITY_LIST:  >> NUMBER, [CLASS_ID, UNIQUE_ID, OWNER][0..NUMBER]
- *  REMOVE_ENTITY_LIST:  >> NUMBER, [UNIQUE_ID][0..NUMBER]
- *
- *  REQUEST_CREATE:      >> CLASS_ID
- *                       << [Sync Info]
- *  REQUEST_REMOVE:      >> UNIQUE_ID
- *                       << [Sync Info]
- *
- *  //REQUEST_CREATE_LIST: NUMBER, [CLASS_ID][0..NUMBER]
- *  //REQUEST_CREATE_LIST: NUMBER, [UNIQUE_ID][0..NUMBER]
- *
- *  REQUEST_ENTITY_LIST: //request the whole world :D
- *  REQUEST_SYNC:        >> UNIQUE_ID
- *                       << [Sync Info]
- *  //REQUEST_SYNC_LIST:   NUMBER, [UNIQUE_ID][0..NUMBER]
- *
- *  YOU_ARE_ENTITY:      >> UNIQUE_ID
- *
- *  REQUEST_PNODE_PATH   >> UNIQUE_ID_START   UNIQUE_ID_STOP
- *                       << UNIQUE_ID_1   UNIQUE_ID_2   UNIQUE_ID_3 ...   UNIQUE_ID_N
- *
- *  SEND_PNODE_PATH      >> UNIQUE_ID_START   UNIQUE_ID_STOP NUMBER [UNIQUE_ID][0..NUMBER]
- */
 
 typedef enum NetworkGameManagerProtocol {
@@ -54,5 +25,4 @@
   NET_REQUEST_CREATE,
   NET_REQUEST_REMOVE,
-  NET_REQUEST_SYNC,
   NET_YOU_ARE_ENTITY,
   NET_REQUEST_ENTITY_LIST,
@@ -81,8 +51,10 @@
     { if (!NetworkGameManager::singletonRef) NetworkGameManager::singletonRef = new NetworkGameManager(); return NetworkGameManager::singletonRef; }
 
+#if 0
     virtual int writeBytes(const byte* data, int length, int sender);
     virtual int readBytes(byte* data, int maxLength, int * reciever);
     virtual void writeDebug() const;
     virtual void readDebug() const;
+#endif
 
     int createEntity( ClassID classID, int owner = 0 );
@@ -91,7 +63,7 @@
     void sendYouAre( int uniqueID, int userID );
 
-    void sync(int uniqueID, int owner);
-
+#if 0
     void sendEntityList(int userID);
+#endif
 
     bool signalNewPlayer(int userId);
@@ -101,4 +73,6 @@
   private:
     NetworkGameManager();
+    
+    static bool youAreHandler(MessageId messageId, byte * data, int dataLength, void * someData, int userId );
 
 
@@ -111,5 +85,4 @@
     bool handleRemoveEntityList( int& i, const byte* data, int length, int sender );
     bool handleYouAreEntity( int& i, const byte* data, int length, int sender );
-    bool handleRequestSync( int& i, const byte* data, int length, int sender );
     bool handleRequestPNodePath(int& i, const byte* data, int length, int sender);
     bool handleSendPNodePath(int& i, const byte* data, int length, int sender);
@@ -117,24 +90,22 @@
 
     /* some network handlers helper functions */
-    void requestCreateEntity(ClassID classID);
+//    void requestCreateEntity(ClassID classID);
     int executeCreateEntity(ClassID classID, int uniqueID = 0, int owner = 0);
     BaseObject* doCreateEntity(ClassID classID, int uniqueID, int owner);
 
-    void requestRemoveEntity(int uniqueID);
+//    void requestRemoveEntity(int uniqueID);
     void executeRemoveEntity(int uniqueID);
     void doRemoveEntity(int uniqueID);
 
-    void executeRequestSync( int uniqueID, int user );
-    void doRequestSync(int uniqueID, int userID);
-
     void doYouAre( int uniqueID );
 
-    void requestPNodePath(const PNode* node1, const PNode* node2);
+//    void requestPNodePath(const PNode* node1, const PNode* node2);
     void executeRequestPNodePath(const PNode* node2, const PNode* node2);
     void doRequestPNodePath(const PNode* node1, const PNode* node2);
 
     bool canCreateEntity(ClassID classID);
+#if 0
+    void resizeBufferVector(int n);
 
-    void resizeBufferVector(int n);
 
     bool writeToClientBuffer( clientBuffer &cb, byte*data, int length );
@@ -142,11 +113,12 @@
     bool writeToClientBuffer( clientBuffer &cb, int i );
     bool readFromClientBuffer( clientBuffer &cb, byte*data, int length );
-
+#endif
 
   private:
+#if 0
     std::vector<clientBuffer>     outBuffer;
     //clientBuffer                  allOutBuffer;
+#endif
     static NetworkGameManager*    singletonRef;
-    bool                          hasRequestedWorld;
 };
 
Index: /trunk/src/lib/network/network_log.cc
===================================================================
--- /trunk/src/lib/network/network_log.cc	(revision 7954)
+++ /trunk/src/lib/network/network_log.cc	(revision 7954)
@@ -0,0 +1,218 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer: ...
+*/
+
+#include "network_log.h"
+
+/**
+ *  the singleton reference to this class
+ */
+NetworkLog* NetworkLog::singletonRef = NULL;
+
+
+/**
+ * standard constructor
+ */
+NetworkLog::NetworkLog ()
+{
+  listensock = NULL;
+}
+
+
+/**
+   @brief standard deconstructor
+ */
+NetworkLog::~NetworkLog ()
+{
+  NetworkLog::singletonRef = NULL;
+}
+
+/**
+ * listens on port for connections
+ * @param port port number
+ * @return true on success
+ */
+bool NetworkLog::listen( int port )
+{
+  IPaddress ip;
+
+  if ( SDLNet_ResolveHost( &ip, NULL, port ) == -1 ) {
+    PRINT(1)( "SDLNet_ResolveHost: %s\n", SDLNet_GetError() );
+    listensock = NULL;
+    return false;
+  }
+  
+  listensock = SDLNet_TCP_Open( &ip );
+  
+  if( !listensock ) {
+    PRINT(1)( "SDLNet_TCP_Open: %s\n", SDLNet_GetError() );
+    return false;
+  } 
+
+  return true;
+}
+
+/**
+ * prints string to all connected sockets
+ */
+void NetworkLog::printfn( char * format, ... )
+{
+  va_list ap;
+  va_start( ap, format );
+  
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+  
+  va_end( ap );
+ 
+  printfnet();
+}
+
+/**
+ * accepts new connections
+ */
+void NetworkLog::acceptNewConnections( )
+{
+  TCPsocket newSock = SDLNet_TCP_Accept( listensock );
+  
+  if ( newSock )
+    sockets.push_back( newSock );
+}
+
+/**
+ * prints to all connected sockets and to PRINTF(0)
+ */
+void NetworkLog::printf0( char * format, ... )
+{
+  va_list ap;
+  va_start( ap, format );
+  
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+  
+  va_end( ap );
+  
+  PRINT(0)( buf );
+  printfnet();
+
+}
+
+/**
+ * prints to all connected sockets and to PRINTF(1)
+ */
+void NetworkLog::printf1( char * format, ... )
+{
+  va_list ap;
+  va_start( ap, format );
+  
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+  
+  va_end( ap );
+  
+  PRINT(1)( buf );
+  printfnet();
+
+}
+
+/**
+ * prints to all connected sockets and to PRINTF(2)
+ */
+void NetworkLog::printf2( char * format, ... )
+{
+  va_list ap;
+  va_start( ap, format );
+  
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+  
+  va_end( ap );
+  
+  PRINT(2)( buf );
+  printfnet();
+
+}
+
+/**
+ * prints to all connected sockets and to PRINTF(3)
+ */
+void NetworkLog::printf3( char * format, ... )
+{
+  va_list ap;
+  va_start( ap, format );
+  
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+  
+  va_end( ap );
+  
+  PRINT(3)( buf );
+  printfnet();
+
+}
+
+/**
+ * prints to all connected sockets and to PRINTF(4)
+ */
+void NetworkLog::printf4( char * format, ... )
+{
+  va_list ap;
+  va_start( ap, format );
+  
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+  
+  va_end( ap );
+  
+  PRINT(4)( buf );
+  printfnet();
+
+}
+
+/**
+ * prints to all connected sockets and to PRINTF(5)
+ */
+void NetworkLog::printf5( char * format, ... )
+{
+  va_list ap;
+  va_start( ap, format );
+  
+  assert( vsnprintf( buf, NETWORK_LOG_BUFLEN, format, ap ) < NETWORK_LOG_BUFLEN );
+  
+  va_end( ap );
+  
+  PRINT(5)( buf );
+  printfnet();
+
+}
+
+
+/**
+ * prints buf to network sockets
+ */
+void NetworkLog::printfnet()
+{
+  if ( !listensock )
+    return;
+  
+  acceptNewConnections();
+
+  for ( std::list<TCPsocket>::iterator it = sockets.begin(); it != sockets.end(); )
+  {
+    if ( SDLNet_TCP_Send( *it, buf, strlen( buf) ) < strlen( buf ) )
+    {
+      SDLNet_TCP_Close( *it );
+      std::list<TCPsocket>::iterator delIt = it;
+      it++;
+      sockets.erase( delIt );
+      continue;
+    }
+    
+    it++;
+  }
+}
Index: /trunk/src/lib/network/network_log.h
===================================================================
--- /trunk/src/lib/network/network_log.h	(revision 7954)
+++ /trunk/src/lib/network/network_log.h	(revision 7954)
@@ -0,0 +1,71 @@
+/*!
+ * @file network_log.h
+ * @brief Definition of the NetworkLog singleton Class
+ */
+
+#ifndef _NETWORK_LOG_H
+#define _NETWORK_LOG_H
+
+#include "netdefs.h"
+#include "debug.h"
+
+#include <string>
+#include <list>
+
+#define NETWORK_LOG_BUFLEN 1024
+
+/* macro definitions */
+#define NETPRINTF(x) NETPRINTF ## x
+#define NETPRINT(x) NETPRINT ## x
+
+#define NETPRINTFn NetworkLog::getInstance()->printfn("%s:%d:", __FILE__, __LINE__); NetworkLog::getInstance()->printfn
+#define NETPRINTF0 NetworkLog::getInstance()->printf0("%s:%d:", __FILE__, __LINE__); NetworkLog::getInstance()->printf0
+#define NETPRINTF1 NetworkLog::getInstance()->printf1("(EE)::%s:%d:", __FILE__, __LINE__); NetworkLog::getInstance()->printf1
+#define NETPRINTF2 NetworkLog::getInstance()->printf2("(WW)::%s:%d:", __FILE__, __LINE__); NetworkLog::getInstance()->printf2
+#define NETPRINTF3 NetworkLog::getInstance()->printf3("(II)::%s:%d:", __FILE__, __LINE__); NetworkLog::getInstance()->printf3
+#define NETPRINTF4 NetworkLog::getInstance()->printf4("(DD)::%s:%d:", __FILE__, __LINE__); NetworkLog::getInstance()->printf4
+#define NETPRINTF5 NetworkLog::getInstance()->printf5("(VD)::%s:%d:", __FILE__, __LINE__); NetworkLog::getInstance()->printf5
+
+#define NETPRINTn NetworkLog::getInstance()->printfn
+#define NETPRINT0 NetworkLog::getInstance()->printf0
+#define NETPRINT1 NetworkLog::getInstance()->printf1
+#define NETPRINT2 NetworkLog::getInstance()->printf2
+#define NETPRINT3 NetworkLog::getInstance()->printf3
+#define NETPRINT4 NetworkLog::getInstance()->printf4
+#define NETPRINT5 NetworkLog::getInstance()->printf5
+
+//! A default singleton class.
+class NetworkLog
+{
+
+  public:
+    virtual ~NetworkLog(void);
+    /** @returns a Pointer to the only object of this Class */
+    inline static NetworkLog* getInstance(void) { if (!singletonRef) singletonRef = new NetworkLog();  return singletonRef; };
+
+    bool listen( int port );
+
+    void printfnet( );
+
+    void printfn( char * format, ... );
+    void printf0( char * format, ... );
+    void printf1( char * format, ... );
+    void printf2( char * format, ... );
+    void printf3( char * format, ... );
+    void printf4( char * format, ... );
+    void printf5( char * format, ... );
+
+  private:
+    NetworkLog();
+
+    void acceptNewConnections();
+
+    static NetworkLog* singletonRef;
+
+    TCPsocket listensock;
+    std::list<TCPsocket> sockets;
+
+    char buf[NETWORK_LOG_BUFLEN];
+};
+
+#endif /* _NETWORK_LOG_H */
Index: /trunk/src/lib/network/network_manager.cc
===================================================================
--- /trunk/src/lib/network/network_manager.cc	(revision 7953)
+++ /trunk/src/lib/network/network_manager.cc	(revision 7954)
@@ -28,4 +28,6 @@
 #include "shared_network_data.h"
 #include "network_stream.h"
+#include "preferences.h"
+#include "network_log.h"
 
 
@@ -52,4 +54,11 @@
   this->defaultSyncStream = NULL;
   this->sharedNetworkData = SharedNetworkData::getInstance();
+  this->elapsedTime = 0.0f;
+  
+    
+  int port = Preferences::getInstance()->getInt( "network", "telnetport", 0 );
+  
+  if ( port > 0 )
+    NetworkLog::getInstance()->listen( port );
 
   PRINTF(0)("NetworkManager created\n");
@@ -72,4 +81,5 @@
   this->netStreamList = ClassList::getList(CL_SYNCHRONIZEABLE);
   PRINTF(0)("NetworkManager initzalized\n");
+
 }
 
@@ -90,12 +100,5 @@
 int NetworkManager::establishConnection(const std::string & name, unsigned int port)
 {
-  IPaddress ipAddress;
-  int error = SDLNet_ResolveHost(&ipAddress, name.c_str(), port);
-  if( error == -1) {
-    printf("\n\nerror on address resolution, program inconsistency\n\n");
-    return -1;
-  }
-
-  this->defaultSyncStream = new NetworkStream(ipAddress);
+  this->defaultSyncStream = new NetworkStream( name, port );
   this->sharedNetworkData->setDefaultSyncStream(this->defaultSyncStream);
   this->defaultSyncStream->startHandshake();
@@ -130,7 +133,13 @@
 /**
  *  sync the network
+ *  @param dtS: the seceonds elapsed since the last synchronize call
  */
-void NetworkManager::synchronize()
+void NetworkManager::synchronize( float dtS)
 {
+  this->elapsedTime += dtS;
+  if( likely(this->elapsedTime < 1.0f / NETWORK_FREQUENCY))
+    return;
+  this->elapsedTime = 0.0f;
+
   if (this->netStreamList != NULL || (this->netStreamList = ClassList::getList(CL_NETWORK_STREAM)) != NULL)
   {
Index: /trunk/src/lib/network/network_manager.h
===================================================================
--- /trunk/src/lib/network/network_manager.h	(revision 7953)
+++ /trunk/src/lib/network/network_manager.h	(revision 7954)
@@ -45,5 +45,5 @@
 
     void connectSynchronizeable(Synchronizeable& sync);
-    void synchronize();
+    void synchronize(float dtS);
 
     void debug();
@@ -61,4 +61,5 @@
 
     SharedNetworkData*               sharedNetworkData;       //!< reference to the shared data
+    float                            elapsedTime;             //!< elapsed time since the last network update
 };
 
